regina::NStandardTriangulation Class Referenceabstract
Standard Triangulations and Subcomplexes

Describes a triangulation or subcomplex of a triangulation whose structure is well-understood. More...

`#include <subcomplex/nstandardtri.h>`

Inheritance diagram for regina::NStandardTriangulation:

## Public Member Functions

virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
virtual NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual std::ostream & | writeName (std::ostream &out) const =0
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
virtual std::ostream & | writeTeXName (std::ostream &out) const =0
| Writes the name of this triangulation in TeX format to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Input and Output
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Describes a triangulation or subcomplex of a triangulation whose structure is well-understood.

An NStandardTriangulation is generally connected with a real triangulation, i.e., an NTriangulation object, which it describes some portion of.

In general NStandardTriangulation objects cannot be constructed directly, but are instead created through static identification routines such as NStandardTriangulation::isStandardTriangulation(NTriangulation*).

Subclasses corresponding to different families of triangulations do not need to override writeTextShort() since this routine is properly implemented in the base class NStandardTriangulation.

## Constructor & Destructor Documentation

regina::NStandardTriangulation::~NStandardTriangulation | ( |  | ) |

inline virtual

A destructor that does nothing.

## Member Function Documentation

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

NAbelianGroup * regina::NStandardTriangulation::getHomologyH1 | ( |  | ) | const

inline virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented in regina::NLayeredSolidTorus, regina::NTriSolidTorus, regina::NLayeredChain, regina::NSpiralSolidTorus, regina::NLayeredTorusBundle, regina::NSnapPeaCensusTri, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NSnappedBall, regina::NTrivialTri, regina::NL31Pillow, and regina::NLayeredChainPair.

NManifold * regina::NStandardTriangulation::getManifold | ( |  | ) | const

inline virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented in regina::NLayeredSolidTorus, regina::NTriSolidTorus, regina::NLayeredChain, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NLayeredTorusBundle, regina::NPlugTriSolidTorus, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::NSnapPeaCensusTri, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, and regina::NBlockedSFS.

std::string regina::NStandardTriangulation::getName | ( |  | ) | const

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

std::string regina::NStandardTriangulation::getTeXName | ( |  | ) | const

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

static NStandardTriangulation* regina::NStandardTriangulation::isStandardTriangulation | ( | NComponent * | component | ) |

static

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(NTriangulation*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

static NStandardTriangulation* regina::NStandardTriangulation::isStandardTriangulation | ( | NTriangulation * | tri | ) |

static

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(NComponent*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

virtual std::ostream& regina::NStandardTriangulation::writeName | ( | std::ostream & | out | ) | const

pure virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implemented in regina::NLayeredSolidTorus, regina::NTriSolidTorus, regina::NLayeredChain, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NLayeredTorusBundle, regina::NPlugTriSolidTorus, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::NSnapPeaCensusTri, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, and regina::NBlockedSFS.

virtual std::ostream& regina::NStandardTriangulation::writeTeXName | ( | std::ostream & | out | ) | const

pure virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implemented in regina::NLayeredSolidTorus, regina::NTriSolidTorus, regina::NLayeredChain, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NLayeredTorusBundle, regina::NPlugTriSolidTorus, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::NSnapPeaCensusTri, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, and regina::NBlockedSFS.

void regina::ShareableObject::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented in regina::NSnapPeaTriangulation, regina::NGroupPresentation, regina::NHomMarkedAbelianGroup, regina::NNormalSurfaceList, regina::NTetrahedron, regina::NSatRegion, regina::NVertex, regina::NEdge, regina::Dim2Triangle, regina::NTriangle, regina::NLayeredSolidTorus, regina::NHomGroupPresentation, regina::NGenericIsomorphism< dim >, regina::NGenericIsomorphism< 2 >, regina::NGenericIsomorphism< 3 >, regina::NTriangulation, regina::NComponent, regina::NTxICore, regina::NTriSolidTorus, regina::NAngleStructureList, regina::Dim2Edge, regina::NBoundaryComponent, regina::NLayeredChain, regina::Dim2Vertex, regina::Dim2Component, regina::NScript, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NSurfaceFilterProperties, regina::NLayeredTorusBundle, regina::NManifold, regina::NPlugTriSolidTorus, regina::NMatrixInt, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::Dim2Triangulation, regina::NSurfaceSubset, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NFileInfo, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::Dim2BoundaryComponent, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, regina::NText, regina::NSurfaceFilterCombination, and regina::NBlockedSFS.

void regina::NStandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nstandardtri.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).